We use ANSI labelled tapes for CASTOR. The ANSI labelled tape
standard specifies that the EOD on tape must be preceeded by a
trailer label.  If during writing your application hits LEOT
(Logical End Of Tape), it must be able to write the trailer label.
However with the default tape driver (st), you cannot write
anything after the LEOT. So the patch clears the error condition
so that the application can write the trailer label (there is some
space available on tape media between LEOT and PEOT=Physical End
Of Tape). There is an ioctl on the other Unix systems to allow
this extra writing. This ioctl is platform dependent.  Hence this
patch.

Index: drivers/scsi/st.c
===================================================================
--- drivers/scsi/st.c	(.../trunk/cernlinux)	(revision 17)
+++ drivers/scsi/st.c	(.../branches/cernlinux/tape_ansi_eof)	(revision 17)
@@ -3367,6 +3367,9 @@
 		}
 
 		STp->recover_reg = 0;		/* Clear after read */
+		/* Support ANSI End-of-Volume processing.
+		 * Originally by Fabien Collin. */
+		STps->eof = ST_NOEOF;
 		retval = 0;
 		goto out;
 	}			/* End of MTIOCGET */
